unit SDRelektor;

interface

uses D2XXUnit,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    FlashBin: TButton;
    ScrollBar1: TScrollBar;
    Freq: TLabel;
    RAMbin: TButton;
    ProgressBar1: TProgressBar;
    LabelFmin: TLabel;
    LabelFmax: TLabel;
    CMD1_4: TButton;
    CMD2_8: TButton;
    Cmd4_16: TButton;
    Cmd10_40: TButton;
    Cmd25_100: TButton;
    ScrollBar2: TScrollBar;
    Offset: TLabel;
    Cmdhigh: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Mux0: TButton;
    Mux1: TButton;
    Mux2: TButton;
    db10: TButton;
    db20: TButton;
    db0: TButton;
    Mux3: TButton;
    ScrollBar3: TScrollBar;
    Label7: TLabel;
    Xtal: TLabel;
    Mux4: TButton;
    Mux5: TButton;
    Mux6: TButton;
    Mux7: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FlashBinClick(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure CMD1_4Click(Sender: TObject);
    procedure CMD2_8Click(Sender: TObject);
    procedure Cmd4_16Click(Sender: TObject);
    procedure Cmd10_40Click(Sender: TObject);
    procedure RAMbinClick(Sender: TObject);
    procedure FtoEEPROMClick(Sender: TObject);
    procedure Cmd25_100Click(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure CmdhighClick(Sender: TObject);
    procedure Mux0Click(Sender: TObject);
    procedure Mux1Click(Sender: TObject);
    procedure Mux2Click(Sender: TObject);
    procedure db20Click(Sender: TObject);
    procedure db10Click(Sender: TObject);
    procedure db0Click(Sender: TObject);
    procedure Mux3Click(Sender: TObject);
    procedure ScrollBar3Change(Sender: TObject);
    procedure Mux4Click(Sender: TObject);
    procedure Mux5Click(Sender: TObject);
    procedure Mux6Click(Sender: TObject);
    procedure Mux7Click(Sender: TObject);
  end;

var
  Form1: TForm1;
  COM: Integer = 2;
   Codearray : array [0..5000] of byte;
   Fehler: Boolean;
  P,Q,Div1N: Integer;
 var R40, R41, R42 : Integer;
   P0: Integer;
    IICadr,n: Integer;
    Step: Real;
    VFOhigh: Boolean;
 FT_port: Integer = 0;
 Buf_adr: Integer = 0;
 Mux: Integer;
 dB: Integer;
implementation

{$R *.DFM}
procedure SCL(d:Integer);
begin
  if d=0 then FT_port := FT_port and (255-2) else FT_port := FT_port or (2); //Bit 2
  FT_Out_Buffer[Buf_adr] := FT_port;
  Buf_adr := Buf_adr +1;
end;

procedure SDA(d:Integer);
begin
  if d=0 then FT_port := FT_port and (255-1) else FT_port := FT_port or (1); //Bit 2
  //FT_port := FT_port and (255-16); //Bit 4
  //FT_port := FT_port + d * 16;
  FT_Out_Buffer[Buf_adr] := FT_port;
  Buf_adr := Buf_adr +1;
end;


procedure I2C_Init;
begin
  SCL(1); SDA(1);          { SCL=1, SDA=1 }
end;

procedure Start;
begin
  SDA(0);          { SDA=0 }
  SCL(0);          { SCL=0 }
end;

procedure Stop;
begin
  SCL(0); SDA(0);  { SCL=0, SDA=0 }
  SCL(1);          { SCL=1 }
  SDA(1);          { SDA=1 }
end;

procedure Acknowledge;
begin
  SCL(0); SDA(0);  { SCL=0, SDA=0 }
  SCL(1);          { SCL=1 }
  SCL(0);          { SCL=0 }
end;

procedure KeinAcknowledge;
begin
  SCL(0); SDA(1);  { SCL=0, SDA=1 }
  SCL(1);          { SCL=1 }
  SCL(0);          { SCL=0 }
end;

Function Ausgeben (Wert : Byte): Boolean;
var Bitwert, n: Byte;
begin
  Ausgeben := true;
  Bitwert := 128;
  for n:= 1 to 8 do begin
    if (Wert and Bitwert) = Bitwert then SDA(1)
     else SDA(0);   { SDA setzen }
    SCL(1);         { SCL=1 }
    SCL(0);         { SCL=0 }
    Bitwert := Bitwert div 2;
  end;
  SDA(1);           { SDA=1 }
  SCL(1);           { SCL=1, SDA lesen }
  SCL(0);           { SCL=0 }
end;



procedure RAM();
var Pump: Integer;
begin
  Buf_adr :=0;
  IICadr:=210;
  Pump := 1;
  If P>479 then Pump := 2;
  If P>639 then Pump := 3;
  If P>799 then Pump := 4;
  P0:= P mod 2;
  R40 := (P div 2 -4 ) div 256 + 4 * Pump + 192;
  R41 := (P div 2 -4) and 255;
  R42 := 48+128*P0;      //q+2=50, 10 MHz / 50 = 200 kHz
  if VFOhigh then R42 := 23+128*P0;      //q+2=25, 10 MHz / 25 = 400 kHz
  //Label2.caption :=IntToStr (P) + ' ' +IntToStr (R40) + ' '+   IntToStr (R41) + ' '+ IntToStr (R42) + ' ';
  I2C_Init;
  Start;
  Ausgeben (IICadr); {Adr 210, RAM}
  Ausgeben (64);       //Adr 40 hex
  Ausgeben (R40);
  Ausgeben (R41);
  Ausgeben (R42);
  Stop;
  Sleep (10);
  Start;
  Ausgeben (IICadr); {Adr 210, RAM}
  Ausgeben (12);       //Adr 0C hex
  Ausgeben (Div1N);    //DIV1N=50
  Stop;
  Start;
  Ausgeben (IICadr); {Adr 210, RAM}
  Ausgeben (19);       //Adr 13 hex
  //Ausgeben (155);    //DIV1N=50
  Ausgeben (Form1.Scrollbar3.position);    //DIV1N=50
  Stop;

  Open_USB_Device;
  Set_USB_Device_BitMode(255,1);
  FT_Current_Baud:=38400;
  Set_USB_Device_BaudRate;
  Write_USB_Device_Buffer( Buf_adr);
  Close_USB_Device;
end;


function HexToInt (Hexzahl: String): Byte;
var h, l: Byte;
begin
  h:= ord (Hexzahl[1])-48;
  if h>9 then h:=h-7;
  l:= ord (Hexzahl[2])-48;
  if l>9 then l:=l-7;
  Result := 16*h+l;
end;

function ByteToHex (Dat: Integer): String;
var   Hi, Lo: Integer;
      LoHex, HiHex: String;
begin
  Lo := Dat and 15;
  Hi := Dat div 16;
  if Hi > 9 then Hi := Hi + 7;
  HiHex := Chr (48+Hi);
  if Lo > 9 then Lo := Lo + 7;
  LoHex := Chr (48+Lo);
  Result := HiHex + LoHex;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  Div1N:=100;
  LabelFmin.Caption := '0.2 MHz';
  LabelFmax.Caption := '0,2 MHz';
  Step := 2;
  VFOhigh := false;
  Div1N:=10;
  LabelFmin.Caption := '2 MHz';
  LabelFmax.Caption := '8 MHz';
  Step := 20;
  //Freq.caption :=  FloatToStr (Scrollbar1.position*Step / 4)+ ' kHz';
   Offset.caption := IntToStr (Scrollbar2.position);
  P :=Scrollbar1.position;
  Freq.caption :=  FloatToStr (P*Step/4+ ScrollBar2.Position) + ' kHz';
  Mux := 0;
  FT_port :=  FT_port and $63;        //0,1 = I2C, 2,3,4=MUX, 5,6=Attenuator
  FT_port :=  FT_port + 4 * Mux;
  RAM;
end;


procedure TForm1.FlashBinClick(Sender: TObject);
VAR  f :File of Byte;
     r,wert :Byte;
     Anzahl: Byte;
     Adresse, m, n, i : Word;
     MaxAdr: Word;
     Code: Byte;
begin
   OpenDialog1.FileName := '*.bin';
   OpenDiaLog1.Execute;
   if OpenDialog1.FileName > '' then begin
     AssignFile(f,OpenDialog1.Filename);
    {$I-} Reset(f); {$I+}
    r:=IOResult;
    IF r = 0 then begin
      Adresse :=0;
      while (not Eof (f)) and (Adresse < 256) do begin
        Read(f,Code);
        Codearray[Adresse] := Code;
        Adresse := Adresse + 1;
      end;
      CloseFile(f);
  IICadr:= 208;
  for n:= 0 to 15 do begin
  Buf_adr :=0;
  I2C_Init;
  Start;
  Ausgeben (IICadr); {Adr 210, RAM, Ack?}
  Ausgeben (n*16);
     for m:= 0 to 15 do begin
       Ausgeben (CodeArray[n*16+m]);
     end;
     Stop;
  Open_USB_Device;
  Set_USB_Device_BitMode(255,1);
  FT_Current_Baud:=38400;
  Set_USB_Device_BaudRate;
  Write_USB_Device_Buffer( Buf_adr);
  Close_USB_Device;

     ProgressBar1.Position := n*16+15;
     Sleep (200);
     ProgressBar1.Position := 0;
   end;
  end;
 end;
end;



procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  P :=Scrollbar1.position;
  Freq.caption :=  FloatToStr (P*Step/4+ ScrollBar2.Position) + ' kHz';
  RAM;
end;

procedure TForm1.CMD1_4Click(Sender: TObject);
begin
  Div1N:=100;
  LabelFmin.Caption := '0.13 MHz';
  LabelFmax.Caption := '0,8 MHz';
  Step := 2;
  Freq.caption :=  FloatToStr (Scrollbar1.position*Step/4)+ ' kHz';
  RAM;
  ScrollBar1.Max := 1600;
  ScrollBar1.Min := 260;
  ScrollBar1.LargeChange := 2;
  VFOhigh := false;
end;

procedure TForm1.CMD2_8Click(Sender: TObject);
begin
  Div1N:=50;
  LabelFmin.Caption := '0.4 MHz';
  LabelFmax.Caption := '1,6 MHz';
  Step := 4;
  Freq.caption :=  FloatToStr (Scrollbar1.position*Step/4)+ ' kHz';
  RAM;
  ScrollBar1.Max := 1600;
  ScrollBar1.Min := 400;
  ScrollBar1.LargeChange := 9;
  VFOhigh := false;
end;

procedure TForm1.Cmd4_16Click(Sender: TObject);
begin
  Div1N:=25;
  LabelFmin.Caption := '0,8 MHz';
  LabelFmax.Caption := '3,2 MHz';
  Step := 8;
  Freq.caption :=  FloatToStr (Scrollbar1.position*Step/4)+ ' kHz';
  RAM;
  ScrollBar1.Max := 1600;
  ScrollBar1.Min := 400;
  ScrollBar1.LargeChange := 1;
  VFOhigh := false;
end;

procedure TForm1.Cmd10_40Click(Sender: TObject);
begin
  Div1N:=10;
  LabelFmin.Caption := '2 MHz';
  LabelFmax.Caption := '8 MHz';
  Step := 20;
  Freq.caption :=  FloatToStr (Scrollbar1.position*Step/4)+ ' kHz';
  RAM;
  ScrollBar1.Max := 1600;
  ScrollBar1.Min := 400;
  ScrollBar1.LargeChange := 1;
  VFOhigh := false;
end;


procedure TForm1.Cmd25_100Click(Sender: TObject);
begin
  Div1N:=5;
  LabelFmin.Caption := '4 MHz';
  LabelFmax.Caption := '16 MHz';
  Step := 40.0;
  Freq.caption :=  FloatToStr (Scrollbar1.position*Step/4)+ ' kHz';
  RAM;
  ScrollBar1.Max := 1600;
  ScrollBar1.Min := 400;
  ScrollBar1.LargeChange := 1;
  VFOhigh := false;
end;

procedure TForm1.RAMbinClick(Sender: TObject);
VAR  f :File of Byte;
     r,wert :Byte;
     Anzahl: Byte;
     Adresse, m, n, i : Word;
     MaxAdr: Word;
     Code: Byte;
begin
   OpenDialog1.FileName := '*.bin';
   OpenDiaLog1.Execute;
   if OpenDialog1.FileName > '' then begin
     AssignFile(f,OpenDialog1.Filename);
    {$I-} Reset(f); {$I+}
    r:=IOResult;
    IF r = 0 then begin
      Adresse :=0;
      while (not Eof (f)) and (Adresse < 256) do begin
        Read(f,Code);
        Codearray[Adresse] := Code;
        Adresse := Adresse + 1;
      end;
      CloseFile(f);
  IICadr:= 210;
  for n:= 0 to 15 do begin
  Buf_adr :=0;
  I2C_Init;
  Start;
  Ausgeben (IICadr); {Adr 210, RAM, Ack?}
  Ausgeben (n*16);
     for m:= 0 to 15 do begin
       Ausgeben (CodeArray[n*16+m]);
     end;
   Stop;
   Open_USB_Device;
  Set_USB_Device_BitMode(255,1);
  FT_Current_Baud:=38400;
  Set_USB_Device_BaudRate;
  Write_USB_Device_Buffer( Buf_adr);
  Close_USB_Device;


     ProgressBar1.Position := n*16+15;
     Sleep (200);
     ProgressBar1.Position := 0;
   end;
  end;
 end;
end;


procedure TForm1.FtoEEPROMClick(Sender: TObject);
var Pump: Integer;
begin
  IICadr:=208;
  Pump := 1;
  If P>479 then Pump := 2;
  If P>639 then Pump := 3;
  If P>799 then Pump := 4;
  P0:= P mod 2;
  R40 := (P div 2 -4 ) div 256 + 4 * Pump + 192;
  R41 := (P div 2 -4) and 255;
  R42 := 48+128*P0;      //q+2=50, 10 MHz / 50 = 200 kHz
  if VFOhigh then R42 := 23+128*P0;      //q+2=25, 10 MHz / 25 = 400 kHz
  //Label2.caption :=IntToStr (P) + ' ' +IntToStr (R40) + ' '+   IntToStr (R41) + ' '+ IntToStr (R42) + ' ';
  Buf_adr :=0;
  I2C_Init;
  Start;
  Ausgeben (IICadr); {Adr 210, RAM}
  Ausgeben (64);       //Adr 40 hex
  Ausgeben (R40);
  Ausgeben (R41);
  Ausgeben (R42);
  Stop;
  Open_USB_Device;
  Set_USB_Device_BitMode(255,1);
  FT_Current_Baud:=38400;
  Set_USB_Device_BaudRate;
  Write_USB_Device_Buffer( Buf_adr);
  Close_USB_Device;
  Sleep (10);
  Buf_adr :=0;
  Start;
  Ausgeben (IICadr); {Adr 210, RAM}
  Ausgeben (12);       //Adr 0C hex
  Ausgeben (Div1N);    //DIV1N=50
  Stop;
  Open_USB_Device;
  Set_USB_Device_BitMode(255,1);
  FT_Current_Baud:=38400;
  Set_USB_Device_BaudRate;
  Write_USB_Device_Buffer( Buf_adr);
  Close_USB_Device;
  Sleep (10);
 end;



procedure TForm1.ScrollBar2Change(Sender: TObject);
begin
  Offset.caption := IntToStr (Scrollbar2.position);
  P :=Scrollbar1.position;
  Freq.caption :=  FloatToStr (P*Step/4+ ScrollBar2.Position) + ' kHz';
end;

procedure TForm1.CmdhighClick(Sender: TObject);
begin
  Div1N:=4;
  LabelFmin.Caption := '4 MHz';
  LabelFmax.Caption := '25 MHz';
  Step := 100.0;
  Freq.caption :=  FloatToStr (Scrollbar1.position*Step/4)+ ' kHz';
  RAM;
  ScrollBar1.Max := 1200;
  ScrollBar1.Min := 400;
  ScrollBar1.LargeChange := 1;
  VFOhigh := true;

end;

procedure TForm1.Mux0Click(Sender: TObject);
begin
  Mux := 0;
  FT_port :=  FT_port and $63;        //0,1 = I2C, 2,3,4=MUX, 5,6=Attenuator
  FT_port :=  FT_port + 4 * Mux;
  RAM;
end;

procedure TForm1.Mux1Click(Sender: TObject);
begin
  Mux := 1;
  FT_port :=  FT_port and $63;
  FT_port :=  FT_port + 4 * Mux;
  RAM;
end;

procedure TForm1.Mux2Click(Sender: TObject);
begin
  Mux := 2;
  FT_port :=  FT_port and $63;
  FT_port :=  FT_port + 4 * Mux;
  RAM;
end;

procedure TForm1.db20Click(Sender: TObject);
begin
  dB := 2;
  FT_port :=  FT_port and $1F;
  FT_port :=  FT_port + 32 * dB;
  RAM;
end;

procedure TForm1.db10Click(Sender: TObject);
begin
  dB := 1;
  FT_port :=  FT_port and $1F;
  FT_port :=  FT_port + 32 * dB;
  RAM;
end;

procedure TForm1.db0Click(Sender: TObject);
begin
  dB := 0;
  FT_port :=  FT_port and $1F;
  FT_port :=  FT_port + 32 * dB;
  RAM;
end;

procedure TForm1.Mux3Click(Sender: TObject);
begin
  Mux := 3;
  FT_port :=  FT_port and $63;
  FT_port :=  FT_port + 4 * Mux;
  RAM;
end;

procedure TForm1.ScrollBar3Change(Sender: TObject);
begin
 RAM;
end;

procedure TForm1.Mux4Click(Sender: TObject);
begin
  Mux := 4;
  FT_port :=  FT_port and $63;
  FT_port :=  FT_port + 4 * Mux;
  RAM;
end;

procedure TForm1.Mux5Click(Sender: TObject);
begin
  Mux := 5;
  FT_port :=  FT_port and $63;
  FT_port :=  FT_port + 4 * Mux;
  RAM;
end;

procedure TForm1.Mux6Click(Sender: TObject);
begin
  Mux := 6;
  FT_port :=  FT_port and $63;
  FT_port :=  FT_port + 4 * Mux;
  RAM;
end;

procedure TForm1.Mux7Click(Sender: TObject);
begin
  Mux := 7;
  FT_port :=  FT_port and $63;
  FT_port :=  FT_port + 4 * Mux;
  RAM;
end;

end.
